#!/usr/bin/env python
# -*- coding: utf-8 -*-

#  PostmasterGS Stamp Album Page Generator for Scribus v1.2.1 (20150309)
#  Brought to you by GermanStamps.net -- http://www.germanstamps.net
#
#  This script is free to use and modify.  However I have invested significant
#  time and effort ino this project, and I simply ask that you leave this block
#  of text intact as recognition of the source of the code.

from __future__ import division
import scribus
from decimal import *

from random import randint

global origUnit
origUnit = scribus.getUnit()
    
# These need to be complte filepaths.
# On a PC, they should be in a format like this -- "C:\Users\Bob\Documents\Stamps\PMGSSAPG_scribus_v1_2_1_setting.txt"
# On a Mac, they should be in a format like this -- "/Users/Bob/Documents/Stamps/PMGSSAPG_scribus_v1_2_1_settings.txt"
global strFileS
strFileS = "/Users/jed/Documents/Stamp Stuff/Software/PMGSSAPG_scribus121/PMGSSAPG_scribus_v1_2_1_settings.txt"
global strFileB
strFileB = "/Users/jed/Documents/Stamp Stuff/Software/PMGSSAPG_scribus121/PMGSSAPG_scribus_v1_2_1_batch.txt"

'''Set global value to convert from millimeters to points'''
global decConversionValue
decConversionValue = float(2.83464657)

def funcImportSettings():
    '''Load the text file'''
    fileHandleS = open(strFileS, 'r')
    fileContentsS = fileHandleS.readlines()
    fileHandleS.close()
    fileContentsS = [item.rstrip('\r\n') for item in fileContentsS]

    '''Strip out the field identifiers to leave just the value, then assign to variables'''
    global strStyle
    strStyle = fileContentsS[0]
    strStyleI = strStyle.find("|")+1
    strStyleL = len(strStyle)
    strStyle = strStyle[strStyleI:strStyleL]
    global strSingleSet
    strSingleSet = fileContentsS[1]
    strSingleSetI = strSingleSet.find("|")+1
    strSingleSetL = len(strSingleSet)
    strSingleSet = strSingleSet[strSingleSetI:strSingleSetL]
    global strSetOrientation
    strSetOrientation = fileContentsS[2]
    strSetOrientationI = strSetOrientation.find("|")+1
    strSetOrientationL = len(strSetOrientation)
    strSetOrientation = strSetOrientation[strSetOrientationI:strSetOrientationL]
    global strSetSpacing
    strSetSpacing = fileContentsS[3]
    strSetSpacingI = strSetSpacing.find("|")+1
    strSetSpacingL = len(strSetSpacing)
    strSetSpacing = (round(float(strSetSpacing[strSetSpacingI:strSetSpacingL]),4))
    strSetSpacing = strSetSpacing * decConversionValue
    global strFrameStyle
    strFrameStyle = fileContentsS[4]
    strFrameStyleI = strFrameStyle.find("|")+1
    strFrameStyleL = len(strFrameStyle)
    strFrameStyle = strFrameStyle[strFrameStyleI:strFrameStyleL]
    global strFrameDouble
    strFrameDouble = fileContentsS[5]
    strFrameDoubleI = strFrameDouble.find("|")+1
    strFrameDoubleL = len(strFrameDouble)
    strFrameDouble = strFrameDouble[strFrameDoubleI:strFrameDoubleL]
    global strFrameSpacing
    strFrameSpacing = fileContentsS[6]
    strFrameSpacingI = strFrameSpacing.find("|")+1
    strFrameSpacingL = len(strFrameSpacing)
    strFrameSpacing = (round(float(strFrameSpacing[strFrameSpacingI:strFrameSpacingL]),4))
    strFrameSpacing = strFrameSpacing * decConversionValue
    global strFrameThicknessOuter
    strFrameThicknessOuter = fileContentsS[7]
    strFrameThicknessOuterI = strFrameThicknessOuter.find("|")+1
    strFrameThicknessOuterL = len(strFrameThicknessOuter)
    strFrameThicknessOuter = (round(float(strFrameThicknessOuter[strFrameThicknessOuterI:strFrameThicknessOuterL]),4))
    strFrameThicknessOuter = strFrameThicknessOuter * decConversionValue
    global strFrameThicknessInner
    strFrameThicknessInner = fileContentsS[8]
    strFrameThicknessInnerI = strFrameThicknessInner.find("|")+1
    strFrameThicknessInnerL = len(strFrameThicknessInner)
    strFrameThicknessInner = (round(float(strFrameThicknessInner[strFrameThicknessInnerI:strFrameThicknessInnerL]),4))
    strFrameThicknessInner = strFrameThicknessInner * decConversionValue
    global strPaddingTop
    strPaddingTop = fileContentsS[9]
    strPaddingTopI = strPaddingTop.find("|")+1
    strPaddingTopL = len(strPaddingTop)
    strPaddingTop = (round(float(strPaddingTop[strPaddingTopI:strPaddingTopL]),4))
    strPaddingTop = strPaddingTop * decConversionValue
    global strPaddingBottom
    strPaddingBottom = fileContentsS[10]
    strPaddingBottomI = strPaddingBottom.find("|")+1
    strPaddingBottomL = len(strPaddingBottom)
    strPaddingBottom = (round(float(strPaddingBottom[strPaddingBottomI:strPaddingBottomL]),4))
    strPaddingBottom = strPaddingBottom * decConversionValue
    global strPaddingLeft
    strPaddingLeft = fileContentsS[11]
    strPaddingLeftI = strPaddingLeft.find("|")+1
    strPaddingLeftL = len(strPaddingLeft)
    strPaddingLeft = (round(float(strPaddingLeft[strPaddingLeftI:strPaddingLeftL]),4))
    strPaddingLeft = strPaddingLeft * decConversionValue
    global strPaddingRight
    strPaddingRight = fileContentsS[12]
    strPaddingRightI = strPaddingRight.find("|")+1
    strPaddingRightL = len(strPaddingRight)
    strPaddingRight = (round(float(strPaddingRight[strPaddingRightI:strPaddingRightL]),4))
    strPaddingRight = strPaddingRight * decConversionValue
    global strMarginTop
    strMarginTop = fileContentsS[13]
    strMarginTopI = strMarginTop.find("|")+1
    strMarginTopL = len(strMarginTop)
    strMarginTop = (round(float(strMarginTop[strMarginTopI:strMarginTopL]),4))
    strMarginTop = strMarginTop * decConversionValue
    global strMarginBottom
    strMarginBottom = fileContentsS[14]
    strMarginBottomI = strMarginBottom.find("|")+1
    strMarginBottomL = len(strMarginBottom)
    strMarginBottom = (round(float(strMarginBottom[strMarginBottomI:strMarginBottomL]),4))
    strMarginBottom = strMarginBottom * decConversionValue
    global strMarginLeft
    strMarginLeft = fileContentsS[15]
    strMarginLeftI = strMarginLeft.find("|")+1
    strMarginLeftL = len(strMarginLeft)
    strMarginLeft = (round(float(strMarginLeft[strMarginLeftI:strMarginLeftL]),4))
    strMarginLeft = strMarginLeft * decConversionValue
    global strMarginRight
    strMarginRight = fileContentsS[16]
    strMarginRightI = strMarginRight.find("|")+1
    strMarginRightL = len(strMarginRight)
    strMarginRight = (round(float(strMarginRight[strMarginRightI:strMarginRightL]),4))
    strMarginRight = strMarginRight * decConversionValue
    global strVerticalSpacing
    strVerticalSpacing = fileContentsS[17]
    strVerticalSpacingI = strVerticalSpacing.find("|")+1
    strVerticalSpacingL = len(strVerticalSpacing)
    strVerticalSpacing = (round(float(strVerticalSpacing[strVerticalSpacingI:strVerticalSpacingL]),4))
    strVerticalSpacing = strVerticalSpacing * decConversionValue
    global strOISpacing
    strOISpacing = fileContentsS[18]
    strOISpacingI = strOISpacing.find("|")+1
    strOISpacingL = len(strOISpacing)
    strOISpacing = (round(float(strOISpacing[strOISpacingI:strOISpacingL]),4))
    strOISpacing = strOISpacing * decConversionValue
    global strTitleInclude
    strTitleInclude = fileContentsS[19]
    strTitleIncludeI = strTitleInclude.find("|")+1
    strTitleIncludeL = len(strTitleInclude)
    strTitleInclude = strTitleInclude[strTitleIncludeI:strTitleIncludeL]
    global strTitleIncludeP
    strTitleIncludeP = strTitleInclude
    global strTitleFont
    strTitleFont = fileContentsS[20]
    strTitleFontI = strTitleFont.find("|")+1
    strTitleFontL = len(strTitleFont)
    strTitleFont = strTitleFont[strTitleFontI:strTitleFontL]
    global strTitleFontSize
    strTitleFontSize = fileContentsS[21]
    strTitleFontSizeI = strTitleFontSize.find("|")+1
    strTitleFontSizeL = len(strTitleFontSize)
    strTitleFontSize = strTitleFontSize[strTitleFontSizeI:strTitleFontSizeL]
    global strTitleFontSpacing
    strTitleFontSpacing = fileContentsS[22]
    strTitleFontSpacingI = strTitleFontSpacing.find("|")+1
    strTitleFontSpacingL = len(strTitleFontSpacing)
    strTitleFontSpacing = strTitleFontSpacing[strTitleFontSpacingI:strTitleFontSpacingL]
    global strTitleRatio
    strTitleRatio = fileContentsS[23]
    strTitleRatioI = strTitleRatio.find("|")+1
    strTitleRatioL = len(strTitleRatio)
    strTitleRatio = (round(float(strTitleRatio[strTitleRatioI:strTitleRatioL]),4))
    global strTitleTextAlign
    strTitleTextAlign = fileContentsS[24]
    strTitleTextAlignI = strTitleTextAlign.find("|")+1
    strTitleTextAlignL = len(strTitleTextAlign)
    strTitleTextAlign = strTitleTextAlign[strTitleTextAlignI:strTitleTextAlignL]
    global strTitleStyle
    strTitleStyle = fileContentsS[25]
    strTitleStyleI = strTitleStyle.find("|")+1
    strTitleStyleL = len(strTitleStyle)
    strTitleStyle = strTitleStyle[strTitleStyleI:strTitleStyleL] 
    global strSetTitle
    strSetTitle = fileContentsS[26]
    strSetTitleI = strSetTitle.find("|")+1
    strSetTitleL = len(strSetTitle)
    strSetTitle = strSetTitle[strSetTitleI:strSetTitleL] 
    global strDateInclude
    strDateInclude = fileContentsS[27]
    strDateIncludeI = strDateInclude.find("|")+1
    strDateIncludeL = len(strDateInclude)
    strDateInclude = strDateInclude[strDateIncludeI:strDateIncludeL]
    global strDateIncludeP
    strDateIncludeP = strDateInclude
    global strDateFont
    strDateFont = fileContentsS[28]
    strDateFontI = strDateFont.find("|")+1
    strDateFontL = len(strDateFont)
    strDateFont = strDateFont[strDateFontI:strDateFontL]
    global strDateFontSize
    strDateFontSize = fileContentsS[29]
    strDateFontSizeI = strDateFontSize.find("|")+1
    strDateFontSizeL = len(strDateFontSize)
    strDateFontSize = strDateFontSize[strDateFontSizeI:strDateFontSizeL]
    global strDateFontSpacing
    strDateFontSpacing = fileContentsS[30]
    strDateFontSpacingI = strDateFontSpacing.find("|")+1
    strDateFontSpacingL = len(strDateFontSpacing)
    strDateFontSpacing = strDateFontSpacing[strDateFontSpacingI:strDateFontSpacingL]
    global strDateRatio
    strDateRatio = fileContentsS[31]
    strDateRatioI = strDateRatio.find("|")+1
    strDateRatioL = len(strDateRatio)
    strDateRatio = (round(float(strDateRatio[strDateRatioI:strDateRatioL]),4))
    global strDateTextAlign
    strDateTextAlign = fileContentsS[32]
    strDateTextAlignI = strDateTextAlign.find("|")+1
    strDateTextAlignL = len(strDateTextAlign)
    strDateTextAlign = strDateTextAlign[strDateTextAlignI:strDateTextAlignL]
    global strDateStyle
    strDateStyle = fileContentsS[33]
    strDateStyleI = strDateStyle.find("|")+1
    strDateStyleL = len(strDateStyle)
    strDateStyle = strDateStyle[strDateStyleI:strDateStyleL]
    global strSetDate
    strSetDate = fileContentsS[34]
    strSetDateI = strSetDate.find("|")+1
    strSetDateL = len(strSetDate)
    strSetDate = strSetDate[strSetDateI:strSetDateL] 
    global strKatalogInclude
    strKatalogInclude = fileContentsS[35]
    strKatalogIncludeI = strKatalogInclude.find("|")+1
    strKatalogIncludeL = len(strKatalogInclude)
    strKatalogInclude = strKatalogInclude[strKatalogIncludeI:strKatalogIncludeL]
    global strKatalogIncludeP
    strKatalogIncludeP = strKatalogInclude
    global strKatalogFont
    strKatalogFont = fileContentsS[36]
    strKatalogFontI = strKatalogFont.find("|")+1
    strKatalogFontL = len(strKatalogFont)
    strKatalogFont = strKatalogFont[strKatalogFontI:strKatalogFontL]
    global strKatalogFontSize
    strKatalogFontSize = fileContentsS[37]
    strKatalogFontSizeI = strKatalogFontSize.find("|")+1
    strKatalogFontSizeL = len(strKatalogFontSize)
    strKatalogFontSize = strKatalogFontSize[strKatalogFontSizeI:strKatalogFontSizeL]
    global strKatalogFontSpacing
    strKatalogFontSpacing = fileContentsS[38]
    strKatalogFontSpacingI = strKatalogFontSpacing.find("|")+1
    strKatalogFontSpacingL = len(strKatalogFontSpacing)
    strKatalogFontSpacing = strKatalogFontSpacing[strKatalogFontSpacingI:strKatalogFontSpacingL]
    global strKatalogRatio
    strKatalogRatio = fileContentsS[39]
    strKatalogRatioI = strKatalogRatio.find("|")+1
    strKatalogRatioL = len(strKatalogRatio)
    strKatalogRatio = (round(float(strKatalogRatio[strKatalogRatioI:strKatalogRatioL]),4))
    global strKatalogTextAlign
    strKatalogTextAlign = fileContentsS[40]
    strKatalogTextAlignI = strKatalogTextAlign.find("|")+1
    strKatalogTextAlignL = len(strKatalogTextAlign)
    strKatalogTextAlign = strKatalogTextAlign[strKatalogTextAlignI:strKatalogTextAlignL]
    global strKatalogStyle
    strKatalogStyle = fileContentsS[41]
    strKatalogStyleI = strKatalogStyle.find("|")+1
    strKatalogStyleL = len(strKatalogStyle)
    strKatalogStyle = strKatalogStyle[strKatalogStyleI:strKatalogStyleL]
    global strSetKatalog
    strSetKatalog = fileContentsS[42]
    strSetKatalogI = strSetKatalog.find("|")+1
    strSetKatalogL = len(strSetKatalog)
    strSetKatalog = strSetKatalog[strSetKatalogI:strSetKatalogL] 
    global strCaptionInclude
    strCaptionInclude = fileContentsS[43]
    strCaptionIncludeI = strCaptionInclude.find("|")+1
    strCaptionIncludeL = len(strCaptionInclude)
    strCaptionInclude = strCaptionInclude[strCaptionIncludeI:strCaptionIncludeL]
    global strCaptionIncludeP
    strCaptionIncludeP = strCaptionInclude
    global strCaptionIncludeXP
    strCaptionIncludeXP = strCaptionInclude
    global strCaptionFont
    strCaptionFont = fileContentsS[44]
    strCaptionFontI = strCaptionFont.find("|")+1
    strCaptionFontL = len(strCaptionFont)
    strCaptionFont = strCaptionFont[strCaptionFontI:strCaptionFontL]
    global strCaptionFontSize
    strCaptionFontSize = fileContentsS[45]
    strCaptionFontSizeI = strCaptionFontSize.find("|")+1
    strCaptionFontSizeL = len(strCaptionFontSize)
    strCaptionFontSize = strCaptionFontSize[strCaptionFontSizeI:strCaptionFontSizeL]
    global strCaptionFontSpacing
    strCaptionFontSpacing = fileContentsS[46]
    strCaptionFontSpacingI = strCaptionFontSpacing.find("|")+1
    strCaptionFontSpacingL = len(strCaptionFontSpacing)
    strCaptionFontSpacing = strCaptionFontSpacing[strCaptionFontSpacingI:strCaptionFontSpacingL]
    global strCaptionRatio
    strCaptionRatio = fileContentsS[47]
    strCaptionRatioI = strCaptionRatio.find("|")+1
    strCaptionRatioL = len(strCaptionRatio)
    strCaptionRatio = (round(float(strCaptionRatio[strCaptionRatioI:strCaptionRatioL]),4))
    global strCaptionTextAlign
    strCaptionTextAlign = fileContentsS[48]
    strCaptionTextAlignI = strCaptionTextAlign.find("|")+1
    strCaptionTextAlignL = len(strCaptionTextAlign)
    strCaptionTextAlign = strCaptionTextAlign[strCaptionTextAlignI:strCaptionTextAlignL]
    global strCaptionStyle
    strCaptionStyle = fileContentsS[49]
    strCaptionStyleI = strCaptionStyle.find("|")+1
    strCaptionStyleL = len(strCaptionStyle)
    strCaptionStyle = strCaptionStyle[strCaptionStyleI:strCaptionStyleL]
    global strSetCaption
    strSetCaption = fileContentsS[50]
    strSetCaptionI = strSetCaption.find("|")+1
    strSetCaptionL = len(strSetCaption)
    strSetCaption = strSetCaption[strSetCaptionI:strSetCaptionL] 
    global strPhotoInclude
    strPhotoInclude = fileContentsS[51]
    strPhotoIncludeI = strPhotoInclude.find("|")+1
    strPhotoIncludeL = len(strPhotoInclude)
    strPhotoInclude = strPhotoInclude[strPhotoIncludeI:strPhotoIncludeL]
    global strPhotoIncludeP
    strPhotoIncludeP = strPhotoInclude
    global strPhotoGreyscale
    strPhotoGreyscale = fileContentsS[52]
    strPhotoGreyscaleI = strPhotoGreyscale.find("|")+1
    strPhotoGreyscaleL = len(strPhotoGreyscale)
    strPhotoGreyscale = strPhotoGreyscale[strPhotoGreyscaleI:strPhotoGreyscaleL]
    global strPhotoRatio
    strPhotoRatio = fileContentsS[53]
    strPhotoRatioI = strPhotoRatio.find("|")+1
    strPhotoRatioL = len(strPhotoRatio)
    strPhotoRatio = strPhotoRatio[strPhotoRatioI:strPhotoRatioL]
    strPhotoRatio = (round(float(strPhotoRatio) / 100,4))
    global strLayoutTitle
    strLayoutTitle = fileContentsS[54]
    strLayoutTitleI = strLayoutTitle.find("|")+1
    strLayoutTitleL = len(strLayoutTitle)
    strLayoutTitle = strLayoutTitle[strLayoutTitleI:strLayoutTitleL]
    global strLayoutDate
    strLayoutDate = fileContentsS[55]
    strLayoutDateI = strLayoutDate.find("|")+1
    strLayoutDateL = len(strLayoutDate)
    strLayoutDate = strLayoutDate[strLayoutDateI:strLayoutDateL]
    global strLayoutKatalog
    strLayoutKatalog = fileContentsS[56]
    strLayoutKatalogI = strLayoutKatalog.find("|")+1
    strLayoutKatalogL = len(strLayoutKatalog)
    strLayoutKatalog = strLayoutKatalog[strLayoutKatalogI:strLayoutKatalogL]
    global strLayoutKatalogO
    strLayoutKatalogO = strLayoutKatalog
    global strLayoutCaption
    strLayoutCaption = fileContentsS[57]
    strLayoutCaptionI = strLayoutCaption.find("|")+1
    strLayoutCaptionL = len(strLayoutCaption)
    strLayoutCaption = strLayoutCaption[strLayoutCaptionI:strLayoutCaptionL] 
    
    '''Convert text alignments to numeric codes'''
    global strTitleTextAlignN
    if strTitleTextAlign == 'Left':
        strTitleTextAlignN = 0
    elif strTitleTextAlign == 'Center':
        strTitleTextAlignN = 1
    elif strTitleTextAlign == 'Right':
        strTitleTextAlignN = 2
    elif strTitleTextAlign == 'Justified':
        strTitleTextAlignN = 3

    global strDateTextAlignN
    if strDateTextAlign == 'Left':
        strDateTextAlignN = 0
    elif strDateTextAlign == 'Center':
        strDateTextAlignN = 1
    elif strDateTextAlign == 'Right':
        strDateTextAlignN = 2
    elif strDateTextAlign == 'Justified':
        strDateTextAlignN = 3
        
    global strKatalogTextAlignN
    if strKatalogTextAlign == 'Left':
        strKatalogTextAlignN = 0
    elif strKatalogTextAlign == 'Center':
        strKatalogTextAlignN = 1
    elif strKatalogTextAlign == 'Right':
        strKatalogTextAlignN = 2
    elif strKatalogTextAlign == 'Justified':
        strKatalogTextAlignN = 3
        
    global strCaptionTextAlignN
    if strCaptionTextAlign == 'Left':
        strCaptionTextAlignN = 0
    elif strCaptionTextAlign == 'Center':
        strCaptionTextAlignN = 1
    elif strCaptionTextAlign == 'Right':
        strCaptionTextAlignN = 2
    elif strCaptionTextAlign == 'Justified':
        strCaptionTextAlignN = 3

    '''Set global text box styles'''
    if strTitleStyle == 'Global':
        scribus.createCharStyle("styTitleC",strTitleFont,float(strTitleFontSize))
        scribus.createParagraphStyle("Title",1,float(strTitleFontSize),strTitleTextAlignN,0,0,0,0,0,0,0,0,"styTitleC")
    if strDateStyle == 'Global':
        scribus.createCharStyle("styDateC",strDateFont,float(strDateFontSize))
        scribus.createParagraphStyle("Date",1,float(strDateFontSize),strDateTextAlignN,0,0,0,0,0,0,0,0,"styDateC")
    if strKatalogStyle == 'Global':
        scribus.createCharStyle("styKatalogC",strKatalogFont,float(strKatalogFontSize))
        scribus.createParagraphStyle("Katalog",1,float(strKatalogFontSize),strKatalogTextAlignN,0,0,0,0,0,0,0,0,"styKatalogC")
    if strCaptionStyle == 'Global':
        scribus.createCharStyle("styCaptionC",strCaptionFont,float(strCaptionFontSize))
        scribus.createParagraphStyle("Caption",1,float(strCaptionFontSize),strCaptionTextAlignN,0,0,0,0,0,0,0,0,"styCaptionC")     

    '''Zero out inner frame data if using single frame'''
    if strFrameDouble == 'FALSE':
        strFrameThicknessInner = 0
        strFrameSpacing = 0

    '''Set frame offset'''
    global strFrameOffset
    strFrameOffset = strFrameThicknessOuter + strFrameSpacing + strFrameThicknessInner
    
    '''Prevent use of Internal frame style with sets'''
    if strSingleSet == 'Set':
        strFrameStyle = 'External'
    
    '''Disable photos if using Internal frame style'''
    if strFrameStyle == 'Internal':
        strPhotoInclude = 'FALSE'

    '''Adjust includes based on style'''
    if strStyle == 'Inside':
        strTitleInclude = 'FALSE'
        strTitleIncludeP = strTitleInclude
        strDateInclude = 'FALSE'
        strDateIncludeP = strDateInclude
        strCaptionInclude = 'FALSE'
        strCaptionIncludeP = strCaptionInclude
        strPhotoInclude = 'FALSE'
        strLayoutKatalog = 'Bottom'
    if strStyle == 'Outside/Inside':
        strLayoutKatalog = 'Bottom'

    '''Prep for Sets'''
    global strSetMaxH
    strSetMaxH = 0
    global strSetMaxW
    strSetMaxW = 0
    global strSetTotH
    strSetTotH = 0
    global strSetTotW
    strSetTotW = 0
    global strSetCount
    strSetCount = 0
    global strSetMaxI
    strSetMaxI = 0

    funcImportBatch()

def funcImportBatch():
    '''This is the first ot two imports.  The first calculates values for group items, the second for individual'''

    '''Load data from the text file'''
    fileHandleB = open(strFileB, 'r')
    fileContentsB = fileHandleB.readlines()
    fileNumLines = len([l for l in fileContentsB if l.strip(' \n') != ''])
    fileHandleB.close
        
    '''Create empty lists for set shapes'''
    global lstFoS
    lstFoS = []
    global lstFiS
    lstFiS = []
    global lstPS
    lstPS = []
    global lstTS
    lstTS = []
    global lstDS
    lstDS = []
    global lstKS
    lstKS = []
    global lstCS
    lstCS = []

    '''Lists to capture data on first run though of sets'''
    global lstStampH
    global lstStampW
    lstStampH = []
    lstStampW = []

    global lstPhoto
    global lstPhotoH
    global lstPhotoW
    lstPhoto = []
    lstPhotoH = []
    lstPhotoW = []

    global lstTitle
    global lstDate
    global lstKatalog
    global lstCaption
    lstTitle = []
    lstDate = []
    lstKatalog = []
    lstCaption = []

    '''Loop through the stamp entries to extract the respective field values from each entry'''
    global icnt
    icnt = 0
    while icnt < (fileNumLines):
        '''Use random numer to give unique shape names'''
        global rnd 
        rnd = str(randint(10000,999999999))
        global rndp
        rndp = rnd

        '''Lists for frame and photo shapes'''
        global lstFo
        global lstFi
        global lstP
        lstFo = []
        lstFi = []
        lstP = []

        '''Lists of Text boxes shapes on each side of frame'''
        global lstTopShp
        global lstBottomShp
        global lstRightShp
        global lstRightShpG
        global lstLeftShp
        global lstLeftShpG
        lstTopShp = []
        lstBottomShp= []
        lstRightShp = []
        lstRightShpG = []
        lstLeftShp = []
        lstLeftShpG = []

        scribus.setUnit(0)
        fileHandleB = open(strFileB, 'r')
        fileLine = fileHandleB.readlines()
        strLineTemp = fileLine[icnt]
        strLineTemp = strLineTemp.replace("~", '\n')
        
        strLineTempI = strLineTemp.find("|")
        strStampHeight = strLineTemp[0:strLineTempI]
        '''if StampHeight was left empty, assign a minimal value'''       
        if strStampHeight == 'NullField':
            strStampHeight = "5"
        strStampHeight = (round(float(strStampHeight),4))
        strStampHeight = strStampHeight * decConversionValue
        lstStampH.append(strStampHeight)

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        strStampWidth = strLineTemp[strLineTempM:strLineTempI]
        '''if StampWidth was left empty, assign a minimal value''' 
        if strStampWidth == 'NullField':
            strStampWidth = "5"
        strStampWidth = (round(float(strStampWidth),4))
        strStampWidth = strStampWidth * decConversionValue
        lstStampW.append(strStampWidth)

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strTitle
        strTitle = strLineTemp[strLineTempM:strLineTempI]
        lstTitle.append(strTitle)
        global strTitleInclude
        strTitleInclude = strTitleIncludeP
        if strTitle == 'NullField':
            strTitleInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strDate
        strDate = strLineTemp[strLineTempM:strLineTempI]
        lstDate.append(strDate)
        global strDateInclude
        strDateInclude = strDateIncludeP
        if strDate == 'NullField':
            strDateInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strKatalog
        strKatalog = strLineTemp[strLineTempM:strLineTempI]
        lstKatalog.append(strKatalog)
        global strKatalogInclude
        strKatalogInclude = strKatalogIncludeP
        if strKatalog == 'NullField':
            strKatalogInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strCaption
        strCaption = strLineTemp[strLineTempM:strLineTempI]
        lstCaption.append(strCaption)
        global strCaptionInclude
        strCaptionInclude = strCaptionIncludeP
        if strCaption == 'NullField':
            strCaptionInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strPhoto
        strPhoto = strLineTemp[strLineTempM:strLineTempI]
        lstPhoto.append(strPhoto)

        global strPhotoHeight
        strPhotoHeight = strStampHeight * strPhotoRatio
        lstPhotoH.append(strPhotoHeight)
        global strPhotoWidth
        strPhotoWidth = strStampWidth * strPhotoRatio
        lstPhotoW.append(strPhotoWidth)

        '''If Single, call the Generate code, otherwise calculate the size of the set box'''
        if strSingleSet == 'Singles':
            funcGenerateSingle()
        else:            
            funcSetCalc()

        '''loop to the next stamp entry'''
        icnt += 1
        fileHandleB.close()

    '''If Set, build the set frame, then run a second import to generate the individual portions'''
    if strSingleSet == 'Set':
        funcGenerateSetFrame()
        if strPhotoInclude == 'TRUE':
            funcGenerateSetPhotos()
        funcImportBatchIndiv()

        scribus.setUnit(origUnit)

def funcImportBatchIndiv():
    '''Load data from the text file'''
    fileHandleB = open(strFileB, 'r')
    fileContentsB = fileHandleB.readlines()
    fileNumLines = len([l for l in fileContentsB if l.strip(' \n') != ''])
    fileHandleB.close

    '''Loop through the stamp entries to extract the respective field values from each entry'''
    global icnt
    icnt = 0
    while icnt < (fileNumLines):
        '''Use icnt as suffix for random numer to give unique shape names'''
        global rnd 
        rnd = str(randint(10000,999999999))
        if icnt == 0:
            global rndp
            rndp = rnd

        '''Lists of Text boxes shapes on each side of frame'''
        global lstTopShp
        global lstBottomShp
        global lstRightShp
        global lstLeftShp
        lstTopShp = []
        lstBottomShp= []
        lstRightShp = []
        lstLeftShp = []

        scribus.setUnit(0)
        fileHandleB = open(strFileB, 'r')
        fileLine = fileHandleB.readlines()
        strLineTemp = fileLine[icnt]
        strLineTemp = strLineTemp.replace("~", '\n')
        
        strLineTempI = strLineTemp.find("|")
        strStampHeight = strLineTemp[0:strLineTempI]
        '''if StampHeight was left empty, assign a minimal value'''       
        if strStampHeight == 'NullField':
            strStampHeight = "5"
        strStampHeight = (round(float(strStampHeight),4))
        strStampHeight = strStampHeight * decConversionValue
        lstStampH.append(strStampHeight)

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        strStampWidth = strLineTemp[strLineTempM:strLineTempI]
        '''if StampWidth was left empty, assign a minimal value''' 
        if strStampWidth == 'NullField':
            strStampWidth = "5"
        strStampWidth = (round(float(strStampWidth),4))
        strStampWidth = strStampWidth * decConversionValue
        lstStampW.append(strStampWidth)

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strTitle
        strTitle = strLineTemp[strLineTempM:strLineTempI]
        lstTitle.append(strTitle)
        global strTitleInclude
        strTitleInclude = strTitleIncludeP
        if strTitle == 'NullField':
            strTitleInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strDate
        strDate = strLineTemp[strLineTempM:strLineTempI]
        lstDate.append(strDate)
        global strDateInclude
        strDateInclude = strDateIncludeP
        if strDate == 'NullField':
            strDateInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strKatalog
        strKatalog = strLineTemp[strLineTempM:strLineTempI]
        lstKatalog.append(strKatalog)
        global strKatalogInclude
        strKatalogInclude = strKatalogIncludeP
        if strKatalog == 'NullField':
            strKatalogInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strCaption
        strCaption = strLineTemp[strLineTempM:strLineTempI]
        lstCaption.append(strCaption)
        global strCaptionInclude
        strCaptionInclude = strCaptionIncludeP
        if strCaption == 'NullField':
            strCaptionInclude = 'FALSE'

        strLineTempM = strLineTempI + 1
        strLineTempI = strLineTemp.find("|",strLineTempM)
        global strPhoto
        strPhoto = strLineTemp[strLineTempM:strLineTempI]
        lstPhoto.append(strPhoto)

        global strPhotoHeight
        strPhotoHeight = strStampHeight * strPhotoRatio
        lstPhotoH.append(strPhotoHeight)
        global strPhotoWidth
        strPhotoWidth = strStampWidth * strPhotoRatio
        lstPhotoW.append(strPhotoWidth)

        '''Generate individual components of set'''
        funcGenerateSetText()

        '''loop to the next stamp entry'''
        icnt += 1
        fileHandleB.close()

    funcGroupAndAlign()

    scribus.setUnit(origUnit)

def funcGenerateSingle():
    '''Calculate frame dimensions'''
    global strFrameInnerHeight
    global strFrameInnerWidth
    global strFrameOuterHeight
    global strFrameOuterWidth

    if strFrameStyle == 'External':
        strFrameInnerHeight = lstStampH[icnt] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
        strFrameInnerWidth = lstStampW[icnt] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
        strFrameOuterHeight = lstStampH[icnt] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
        strFrameOuterWidth = lstStampW[icnt] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
    else:
        strFrameOuterHeight = lstStampH[icnt] * .9
        strFrameOuterWidth = lstStampW[icnt] * .9

    '''Set default placement to page center'''
    global strPlacementX
    global strPlacementY

    pageWidth, pageHeight = scribus.getPageSize()
    topMargin, leftMargin, rightMargin, bottomMargin = scribus.getPageMargins()
        
    printAreaWidth  = pageWidth - leftMargin - rightMargin
    printAreaHeight = pageHeight - topMargin - bottomMargin 
    
    if strFrameStyle == 'External':
        strPlacementX = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4))
        strPlacementY = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4))
    else:
        strPlacementX = (round(float((printAreaWidth - lstStampW[icnt])/2 + leftMargin),4))
        strPlacementY = (round(float((printAreaHeight - lstStampH[icnt])/2 + topMargin),4))

    '''Draw the frame'''
    if strFrameStyle == 'External':
        if strFrameDouble == 'TRUE':
            global shpFo
            shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
            strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
            (strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + rnd)
            scribus.setLineWidth(strFrameThicknessOuter, shpFo)
            lstFo.append(shpFo)

            global shpFi
            shpFi = scribus.createRect(strPlacementX + (strFrameThicknessInner / 2), \
            strPlacementY + (strFrameThicknessInner / 2), (strFrameInnerWidth - strFrameThicknessInner), \
            (strFrameInnerHeight - strFrameThicknessInner), 'shpFi' + rnd)
            scribus.setLineWidth(strFrameThicknessInner, shpFi)
            lstFi.append(shpFi)

            strFrameAlignOffset = strFrameThicknessOuter + strFrameSpacing
            scribus.setProperty(shpFi, "xPos", scribus.getProperty(shpFi, "xPos") + strFrameAlignOffset)
            scribus.setProperty(shpFi, "yPos", scribus.getProperty(shpFi, "yPos") + strFrameAlignOffset)
        else:
            global shpFo
            shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
            strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
            (strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + rnd)
            scribus.setLineWidth(strFrameThicknessOuter, shpFo)
            lstFo.append(shpFo)
    else:
        global shpFo
        shpFo = scribus.createRect(strPlacementX + (lstStampW[icnt] * .075), strPlacementY + \
        (lstStampH[icnt] * .075), strFrameOuterWidth, strFrameOuterHeight, 'shpFo' + rnd)
        scribus.setLineWidth(strFrameThicknessOuter, shpFo)
        lstFo.append(shpFo)

    '''Add the photo'''
    if strPhotoInclude == 'TRUE':
        if lstPhoto[icnt] != 'NullField':
            global shpP
            shpP = scribus.createImage(strPlacementX + strFrameOffset, strPlacementY + strFrameOffset, \
            lstPhotoW[icnt], lstPhotoH[icnt], 'shpP' + rnd)
            strPhotoAlignOffsetX = strPaddingLeft + ((lstStampW[icnt] - lstPhotoW[icnt]) / 2)
            scribus.setProperty(shpP, "xPos", scribus.getProperty(shpP, "xPos") + strPhotoAlignOffsetX)
            strPhotoAlignOffsetY = strPaddingTop + ((lstStampH[icnt] - lstPhotoH[icnt]) / 2)
            scribus.setProperty(shpP, "yPos", scribus.getProperty(shpP, "yPos") + strPhotoAlignOffsetY)
            scribus.loadImage(lstPhoto[icnt], shpP)        
            scribus.setScaleImageToFrame(True, True, shpP)
            '''if strPhotoGreyscale.startswith('TRUE'):'''  
            lstP.append(shpP)     

    '''Cue the text boxes'''
    if strTitleInclude == 'TRUE':
        funcTitlePlacementX()
    if strDateInclude == 'TRUE':
        funcDatePlacementX()
    if strKatalogInclude == 'TRUE':
        funcKatalogPlacementX()
    if strCaptionInclude == 'TRUE':
        funcCaptionPlacementX()
    funcCenterMiddles()
    funcTopPlacementY()
    funcBottomPlacementY()
    funcRightPlacementY()
    funcLeftPlacementY()
    funcGroupAndAlign()

    scribus.setUnit(origUnit)

def funcSetCalc():
    global strSetMaxH
    global strSetMaxW
    global strSetTotH
    global strSetTotW
    global strSetCount
    global strSetMaxI

    '''Store max height/width of stamps in set, and aggregate height/width'''
    if strSetOrientation == 'Horizontal':
        if lstStampH[icnt] > strSetMaxH:
                strSetMaxH = lstStampH[icnt]
                strSetMaxI = icnt
        strSetTotW = strSetTotW + lstStampW[icnt]
    else:
        if lstStampW[icnt] > strSetMaxW:
                strSetMaxW = lstStampW[icnt]
                strSetMaxI = icnt
        strSetTotH = strSetTotH + lstStampH[icnt]
    strSetCount += 1

def funcGenerateSetFrame():
    global strFrameInnerHeight
    global strFrameInnerWidth
    global strFrameOuterHeight
    global strFrameOuterWidth

    if strSetOrientation == 'Horizontal':
        strFrameInnerHeight = strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
        strFrameInnerWidth = strSetTotW + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2) + ((strSetCount - 1) * strSetSpacing)
        strFrameOuterHeight = strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
        strFrameOuterWidth = strSetTotW + strPaddingLeft + strPaddingRight + (strFrameOffset * 2) + ((strSetCount - 1) * strSetSpacing)
    else:
        strFrameInnerHeight = strSetTotH + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2) + ((strSetCount - 1) * strSetSpacing)
        strFrameInnerWidth = strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
        strFrameOuterHeight = strSetTotH + strPaddingTop + strPaddingBottom + (strFrameOffset * 2) + ((strSetCount - 1) * strSetSpacing)
        strFrameOuterWidth = strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)

    '''Set default placement to page center'''
    global strPlacementX
    global strPlacementY
    global strPlacementXo
    global strPlacementYo

    pageWidth, pageHeight = scribus.getPageSize()
    topMargin, leftMargin, rightMargin, bottomMargin = scribus.getPageMargins()
        
    printAreaWidth  = pageWidth - leftMargin - rightMargin
    printAreaHeight = pageHeight - topMargin - bottomMargin 
    
    strPlacementX = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4))
    strPlacementY = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4))
    strPlacementXo = strPlacementX
    strPlacementYo = strPlacementY

    '''Draw the frame'''
    if strFrameDouble == 'TRUE':
        global shpFo
        shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
        strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
        (strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + rnd)
        scribus.setLineWidth(strFrameThicknessOuter, shpFo)
        lstFo.append(shpFo)

        global shpFi
        shpFi = scribus.createRect(strPlacementX + (strFrameThicknessInner / 2), \
        strPlacementY + (strFrameThicknessInner / 2), (strFrameInnerWidth - strFrameThicknessInner), \
        (strFrameInnerHeight - strFrameThicknessInner), 'shpFi' + rnd)
        scribus.setLineWidth(strFrameThicknessInner, shpFi)
        lstFi.append(shpFi)

        strFrameAlignOffset = strFrameThicknessOuter + strFrameSpacing
        scribus.setProperty(shpFi, "xPos", scribus.getProperty(shpFi, "xPos") + strFrameAlignOffset)
        scribus.setProperty(shpFi, "yPos", scribus.getProperty(shpFi, "yPos") + strFrameAlignOffset)
    else:
        global shpFo
        shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
        strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
        (strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + rnd)
        scribus.setLineWidth(strFrameThicknessOuter, shpFo)
        lstFo.append(shpFo)

def funcGenerateSetPhotos():
    '''Create working copy of global Placement variables'''
    strPlacementXp = strPlacementX
    strPlacementYp = strPlacementY

    '''Add the photos'''
    pcnt = 0
    while pcnt < icnt:
        global rndv
        rndv = rnd + str(pcnt)
        if strSetOrientation == 'Horizontal':
            if lstPhoto[pcnt] == 'NullField':
                strPlacementXp = strPlacementXp + strFrameOffset + strPaddingLeft + lstStampW[pcnt]
            else:
                shpP = scribus.createImage(strPlacementXp, strPlacementYp, lstPhotoW[pcnt], lstPhotoH[pcnt], 'shpP' + rndv)
                if pcnt == 0:
                    strPhotoAlignOffsetX = strFrameOffset + strPaddingLeft + ((lstStampW[pcnt] - lstPhotoW[pcnt]) / 2)
                else:
                    strPhotoAlignOffsetX = strSetSpacing + ((lstStampW[pcnt] - lstPhotoW[pcnt]) / 2)
                scribus.setProperty(shpP, "xPos", scribus.getProperty(shpP, "xPos") + strPhotoAlignOffsetX)
                strPhotoAlignOffsetY = strPaddingTop + strFrameOffset + ((strSetMaxH - lstStampH[pcnt]) / 2) + ((lstStampH[pcnt] - lstPhotoH[pcnt]) / 2)
                scribus.setProperty(shpP, "yPos", scribus.getProperty(shpP, "yPos") + strPhotoAlignOffsetY)
                scribus.loadImage(lstPhoto[pcnt], shpP)
                scribus.setScaleImageToFrame(True, True, shpP)
                lstPS.append(shpP) 
                strPlacementXp = strPlacementXp + strFrameOffset + strPaddingLeft + lstStampW[pcnt]
        else:
            if lstPhoto[pcnt] == 'NullField':
                strPlacementYp = strPlacementYp + strFrameOffset + strPaddingTop + lstStampH[pcnt]
            else:
                shpP = scribus.createImage(strPlacementXp, strPlacementYp, lstPhotoW[pcnt], lstPhotoH[pcnt], 'shpP' + rndv)
                strPhotoAlignOffsetX = strFrameOffset + strPaddingLeft + ((strSetMaxW - lstStampW[pcnt]) / 2) + ((lstStampW[pcnt] - lstPhotoW[pcnt]) / 2)
                scribus.setProperty(shpP, "xPos", scribus.getProperty(shpP, "xPos") + strPhotoAlignOffsetX)
                if pcnt == 0:
                    strPhotoAlignOffsetY = strFrameOffset + strPaddingTop + ((lstStampH[pcnt] - lstPhotoH[pcnt]) / 2)
                else:
                    strPhotoAlignOffsetY = strSetSpacing + ((lstStampH[pcnt] - lstPhotoH[pcnt]) / 2)
                scribus.setProperty(shpP, "yPos", scribus.getProperty(shpP, "yPos") + strPhotoAlignOffsetY)
                scribus.loadImage(lstPhoto[pcnt], shpP)        
                scribus.setScaleImageToFrame(True, True, shpP)
                lstPS.append(shpP) 
                strPlacementYp = strPlacementYp + strFrameOffset + strPaddingTop + lstStampH[pcnt]
        pcnt += 1

def funcGenerateSetText():
    global strPlacementX
    global strPlacementY

    '''Set new placement starting point if using individual Titles'''
    if strSetOrientation == 'Horizontal':
        if icnt == 0:
            strPlacementY = scribus.getProperty(shpFo, "yPos")
            strPlacementX = strPlacementX + strFrameOffset + strPaddingLeft
    else:
        if icnt == 0:
            strPlacementY = scribus.getProperty(shpFo, "yPos")
            strPlacementY = strPlacementY + strFrameOffset + strPaddingTop

    if strTitleInclude == 'TRUE':
       funcTitlePlacementX()
    if strDateInclude == 'TRUE':
        funcDatePlacementX()
    if strKatalogInclude == 'TRUE':
        funcKatalogPlacementX()
    if strCaptionInclude == 'TRUE':
        funcCaptionPlacementX()
    funcCenterMiddles()
    funcTopPlacementY()
    funcBottomPlacementY()
    funcRightPlacementY()
    funcLeftPlacementY()

    if strSetOrientation == 'Horizontal':
        strPlacementX = strPlacementX + lstStampW[icnt] + strSetSpacing 
    else:
        strPlacementY = strPlacementY + lstStampH[icnt] + strSetSpacing 

def funcTitlePlacementX():
    '''Create working copy of global Placement variables'''
    strPlacementXt = strPlacementX
    strPlacementYt = strPlacementY

    '''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
    if strFrameStyle == 'Internal':
        strFrameOuterWidthI = lstStampW[icnt]
        strFrameOuterHeightI = lstStampH[icnt]
    else:
        strFrameOuterWidthI = strFrameOuterWidth
        strFrameOuterHeightI = strFrameOuterHeight

    '''Substitute stamp width for frame width when building individual components of set'''
    if strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
        strFrameOuterWidthI = lstStampW[icnt]

    '''Add the Titles'''
    global shpTt
    global shpTb
    global shpTr
    global shpTl
    global shpTitleHot

    if strSingleSet == 'Set' and strSetTitle == 'Group' and icnt == 0:
        strTitleWidth = strFrameOuterWidth * strTitleRatio / 100
        strTitleHeight = float(10)
        strTitleShift = ((strTitleWidth - strFrameOuterWidth) / 2)
        if strLayoutTitle == 'Top':
            strTitleLeft = strPlacementXo - strTitleShift
            shpTt = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTt' + rnd)
            lstTopShp.append(shpTt)
            scribus.setText(strTitle, shpTt)
            shpTitleHot = shpTt
        elif strLayoutTitle == 'Bottom':
            strTitleLeft = strPlacementXo - strTitleShift
            shpTb = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTb' + rnd)
            lstBottomShp.append(shpTb)
            scribus.setText(strTitle, shpTb)
            shpTitleHot = shpTb
        elif strLayoutTitle == 'Right':
            strTitleLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
            shpTr = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTr' + rnd)
            lstRightShpG.append(shpTr)
            scribus.setText(strTitle, shpTr)
            shpTitleHot = shpTr
        elif strLayoutTitle == 'Left':
            strTitleLeft = strPlacementXo - strMarginLeft - strTitleWidth
            shpTl = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTl' + rnd)
            lstLeftShpG.append(shpTl)
            scribus.setText(strTitle, shpTl)
            shpTitleHot = shpTl

        if strTitleStyle == 'Global':
            TextLengthT = scribus.getTextLength(shpTitleHot)
            scribus.selectText(0,TextLengthT,shpTitleHot)
            scribus.setStyle("Title",shpTitleHot)
        else:
            scribus.setFont(strTitleFont, shpTitleHot)
            scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
            if strTitleTextAlign == 'Left':
                scribus.setTextAlignment(0, shpTitleHot)
            elif strTitleTextAlign == "Center":
                scribus.setTextAlignment(1, shpTitleHot)
            elif strTitleTextAlign == 'Right':
                scribus.setTextAlignment(2, shpTitleHot)
            elif strTitleTextAlign == "Justified":
                scribus.setTextAlignment(3, shpTitleHot)    
            scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)

        (Tw, Th) = scribus.getSize(shpTitleHot)
        while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
            Th -= 1
            scribus.sizeObject(Tw, Th, shpTitleHot)
        while ((scribus.textOverflows(shpTitleHot) > 0)) :
            Th += 1
            scribus.sizeObject(Tw, Th, shpTitleHot)
        lstTS.append(shpTitleHot)
    elif strSingleSet == 'Set' and strSetTitle == 'Group' and icnt > 0:
        pass
    else:
        strTitleWidth = strFrameOuterWidthI * strTitleRatio / 100
        strTitleHeight = float(10)
        strTitleShift = ((strTitleWidth - strFrameOuterWidthI) / 2)
        if strLayoutTitle == 'Top':
            strTitleLeft = strPlacementXt - strTitleShift
            shpTt = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTt' + rnd)
            lstTopShp.append(shpTt)
            scribus.setText(strTitle, shpTt)
            shpTitleHot = shpTt
        elif strLayoutTitle == 'Bottom':
            strTitleLeft = strPlacementXt - strTitleShift
            shpTb = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTb' + rnd)
            lstBottomShp.append(shpTb)
            scribus.setText(strTitle, shpTb)
            shpTitleHot = shpTb
        elif strLayoutTitle == 'Right':
            strTitleLeft = strPlacementXt + strFrameOuterWidthI + strMarginRight
            shpTr = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTr' + rnd)
            lstRightShp.append(shpTr)
            scribus.setText(strTitle, shpTr)
            shpTitleHot = shpTr
        elif strLayoutTitle == 'Left':
            strTitleLeft = strPlacementXt - strMarginLeft - strTitleWidth
            shpTl = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTl' + rnd)
            lstLeftShp.append(shpTl)
            scribus.setText(strTitle, shpTl)
            shpTitleHot = shpTl

        if strTitleStyle == 'Global':
            TextLengthT = scribus.getTextLength(shpTitleHot)
            scribus.selectText(0,TextLengthT,shpTitleHot)
            scribus.setStyle("Title",shpTitleHot)
        else:
            scribus.setFont(strTitleFont, shpTitleHot)
            scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
            if strTitleTextAlign == 'Left':
                scribus.setTextAlignment(0, shpTitleHot)
            elif strTitleTextAlign == "Center":
                scribus.setTextAlignment(1, shpTitleHot)
            elif strTitleTextAlign == 'Right':
                scribus.setTextAlignment(2, shpTitleHot)
            elif strTitleTextAlign == "Justified":
                scribus.setTextAlignment(3, shpTitleHot)    
            scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)

        (Tw, Th) = scribus.getSize(shpTitleHot)
        while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
            Th -= 1
            scribus.sizeObject(Tw, Th, shpTitleHot)
        while ((scribus.textOverflows(shpTitleHot) > 0)) :
            Th += 1
            scribus.sizeObject(Tw, Th, shpTitleHot)
        lstTS.append(shpTitleHot)

def funcDatePlacementX():
    '''Create working copy of global Placement variables'''
    strPlacementXd = strPlacementX
    strPlacementYd = strPlacementY

    '''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
    if strFrameStyle == 'Internal':
        strFrameOuterWidthI = lstStampW[icnt]
        strFrameOuterHeightI = lstStampH[icnt]
    else:
        strFrameOuterWidthI = strFrameOuterWidth
        strFrameOuterHeightI = strFrameOuterHeight

    '''Substitute stamp width for frame width when building individual components of set'''
    if strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
        strFrameOuterWidthI = lstStampW[icnt]

    '''Add the Dates'''
    global shpDt
    global shpDb
    global shpDr
    global shpDl
    global shpDateHot

    if strSingleSet == 'Set' and strSetDate == 'Group' and icnt == 0:
        strDateWidth = strFrameOuterWidth * strDateRatio / 100
        strDateHeight = float(10)
        strDateShift = ((strDateWidth - strFrameOuterWidth) / 2)
        if strLayoutDate == 'Top':
            strDateLeft = strPlacementXo - strDateShift
            shpDt = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDt' + rnd)
            scribus.setText(strDate, shpDt)
            lstTopShp.append(shpDt)
            shpDateHot = shpDt
        elif strLayoutDate == 'Bottom':
            strDateLeft = strPlacementXo - strDateShift
            shpDb = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDb' + rnd)
            scribus.setText(strDate, shpDb)
            lstBottomShp.append(shpDb)
            shpDateHot = shpDb
        elif strLayoutDate == 'Right':
            strDateLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
            shpDr = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDr' + rnd)
            scribus.setText(strDate, shpDr)
            lstRightShpG.append(shpDr)
            shpDateHot = shpDr
        elif strLayoutDate == 'Left':
            strDateLeft = strPlacementXo - strMarginLeft - strDateWidth
            shpDl = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDl' + rnd)
            scribus.setText(strDate, shpDl)
            lstLeftShpG.append(shpDl)
            shpDateHot = shpDl

        if strDateStyle == 'Global':
            TextLengthD = scribus.getTextLength(shpDateHot)
            scribus.selectText(0,TextLengthD,shpDateHot)
            scribus.setStyle("Date",shpDateHot)
        else:
            scribus.setFont(strDateFont, shpDateHot)
            scribus.setFontSize(float(strDateFontSize), shpDateHot)
            if strDateTextAlign == 'Left':
                scribus.setTextAlignment(0, shpDateHot)
            elif strDateTextAlign == "Center":
                scribus.setTextAlignment(1, shpDateHot)
            elif strDateTextAlign == 'Right':
                scribus.setTextAlignment(2, shpDateHot)
            elif strDateTextAlign == "Justified":
                scribus.setTextAlignment(3, shpDateHot)    
            scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)

        (Dw, Dh) = scribus.getSize(shpDateHot)
        while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
            Dh -= 1
            scribus.sizeObject(Dw, Dh, shpDateHot)
        while ((scribus.textOverflows(shpDateHot) > 0)) :
            Dh += 1
            scribus.sizeObject(Dw, Dh, shpDateHot)
        lstDS.append(shpDateHot)
    elif strSingleSet == 'Set' and strSetDate == 'Group' and icnt > 0:
        pass
    else:
        strDateWidth = strFrameOuterWidthI * strDateRatio / 100
        strDateHeight = float(10)
        strDateShift = ((strDateWidth - strFrameOuterWidthI) / 2)
        if strLayoutDate == 'Top':
            strDateLeft = strPlacementXd - strDateShift
            shpDt = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDt' + rnd)
            scribus.setText(strDate, shpDt)
            lstTopShp.append(shpDt)
            shpDateHot = shpDt
        elif strLayoutDate == 'Bottom':
            strDateLeft = strPlacementXd - strDateShift
            shpDb = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDb' + rnd)
            scribus.setText(strDate, shpDb)
            lstBottomShp.append(shpDb)
            shpDateHot = shpDb
        elif strLayoutDate == 'Right':
            strDateLeft = strPlacementXd + strFrameOuterWidthI + strMarginRight
            shpDr = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDr' + rnd)
            scribus.setText(strDate, shpDr)
            lstRightShp.append(shpDr)
            shpDateHot = shpDr
        elif strLayoutDate == 'Left':
            strDateLeft = strPlacementXd - strMarginLeft - strDateWidth
            shpDl = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDl' + rnd)
            scribus.setText(strDate, shpDl)
            lstLeftShp.append(shpDl)
            shpDateHot = shpDl

        if strDateStyle == 'Global':
            TextLengthD = scribus.getTextLength(shpDateHot)
            scribus.selectText(0,TextLengthD,shpDateHot)
            scribus.setStyle("Date",shpDateHot)
        else:
            scribus.setFont(strDateFont, shpDateHot)
            scribus.setFontSize(float(strDateFontSize), shpDateHot)
            if strDateTextAlign == 'Left':
                scribus.setTextAlignment(0, shpDateHot)
            elif strDateTextAlign == "Center":
                scribus.setTextAlignment(1, shpDateHot)
            elif strDateTextAlign == 'Right':
                scribus.setTextAlignment(2, shpDateHot)
            elif strDateTextAlign == "Justified":
                scribus.setTextAlignment(3, shpDateHot)    
            scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)

        (Dw, Dh) = scribus.getSize(shpDateHot)
        while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
            Dh -= 1
            scribus.sizeObject(Dw, Dh, shpDateHot)
        while ((scribus.textOverflows(shpDateHot) > 0)) :
            Dh += 1
            scribus.sizeObject(Dw, Dh, shpDateHot)
        lstDS.append(shpDateHot)

def funcKatalogPlacementX():
    '''Create working copy of global Placement variables'''
    strPlacementXk = strPlacementX
    strPlacementYk = strPlacementY

    '''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
    if strFrameStyle == 'Internal':
        strFrameOuterWidthI = lstStampW[icnt]
        strFrameOuterHeightI = lstStampH[icnt]
        global strKatalogRatio
        if strKatalogRatio > 90:
            strKatalogRatio = 90
    else:
        strFrameOuterWidthI = strFrameOuterWidth
        strFrameOuterHeightI = strFrameOuterHeight

    '''Substitute stamp width for frame width when building individual components of set'''
    if strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
        strFrameOuterWidthI = lstStampW[icnt]

    '''Add the Katalogs'''
    global shpKt
    global shpKb
    global shpKr
    global shpKl
    global shpKatalogHot

    if strSingleSet == 'Set' and strSetKatalog == 'Group' and icnt == 0:
        strKatalogWidth = strFrameOuterWidth * strKatalogRatio / 100
        strKatalogHeight = float(10)
        strKatalogShift = ((strKatalogWidth - strFrameOuterWidth) / 2)
        if strLayoutKatalog == 'Top':
            strKatalogLeft = strPlacementXo - strKatalogShift
            shpKt = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKt' + rnd)
            lstTopShp.append(shpKt)
            scribus.setText(strKatalog, shpKt)
            shpKatalogHot = shpKt
        elif strLayoutKatalog == 'Bottom':
            strKatalogLeft = strPlacementXo - strKatalogShift
            shpKb = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKb' + rnd)
            lstBottomShp.append(shpKb)
            scribus.setText(strKatalog, shpKb)
            shpKatalogHot = shpKb
        elif strLayoutKatalog == 'Right':
            strKatalogLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
            shpKr = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKr' + rnd)
            lstRightShpG.append(shpKr)
            scribus.setText(strKatalog, shpKr)
            shpKatalogHot = shpKr
        elif strLayoutKatalog == 'Left':
            strKatalogLeft = strPlacementXo - strMarginLeft - strKatalogWidth
            shpKl = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKl' + rnd)
            lstLeftShpG.append(shpKl)
            scribus.setText(strKatalog, shpKl)
            shpKatalogHot = shpKl

        if strKatalogStyle == 'Global':
            TextLengthK = scribus.getTextLength(shpKatalogHot)
            scribus.selectText(0,TextLengthK,shpKatalogHot)
            scribus.setStyle("Katalog",shpKatalogHot)
        else:
            scribus.setFont(strKatalogFont, shpKatalogHot)
            scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
            if strKatalogTextAlign == 'Left':
                scribus.setTextAlignment(0, shpKatalogHot)
            elif strKatalogTextAlign == "Center":
                scribus.setTextAlignment(1, shpKatalogHot)
            elif strKatalogTextAlign == 'Right':
                scribus.setTextAlignment(2, shpKatalogHot)
            elif strKatalogTextAlign == "Justified":
                scribus.setTextAlignment(3, shpKatalogHot)    
            scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)

        (Kw, Kh) = scribus.getSize(shpKatalogHot)
        while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
            Kh -= 1
            scribus.sizeObject(Kw, Kh, shpKatalogHot)
        while ((scribus.textOverflows(shpKatalogHot) > 0)) :
            Kh += 1
            scribus.sizeObject(Kw, Kh, shpKatalogHot)
        lstKS.append(shpKatalogHot)
    elif strSingleSet == 'Set' and strSetKatalog == 'Group' and icnt > 0:
        pass
    else:
        strKatalogWidth = strFrameOuterWidthI * strKatalogRatio / 100
        strKatalogHeight = float(10)
        strKatalogShift = ((strKatalogWidth - strFrameOuterWidthI) / 2)
        if strLayoutKatalog == 'Top':
            strKatalogLeft = strPlacementXk - strKatalogShift
            shpKt = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKt' + rnd)
            lstTopShp.append(shpKt)
            scribus.setText(strKatalog, shpKt)
            shpKatalogHot = shpKt
        elif strLayoutKatalog == 'Bottom':
            strKatalogLeft = strPlacementXk - strKatalogShift
            shpKb = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKb' + rnd)
            lstBottomShp.append(shpKb)
            scribus.setText(strKatalog, shpKb)
            shpKatalogHot = shpKb
        elif strLayoutKatalog == 'Right':
            strKatalogLeft = strPlacementXk + strFrameOuterWidthI + strMarginRight
            shpKr = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKr' + rnd)
            lstRightShp.append(shpKr)
            scribus.setText(strKatalog, shpKr)
            shpKatalogHot = shpKr
        elif strLayoutKatalog == 'Left':
            strKatalogLeft = strPlacementXk - strMarginLeft - strKatalogWidth
            shpKl = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKl' + rnd)
            lstLeftShp.append(shpKl)
            scribus.setText(strKatalog, shpKl)
            shpKatalogHot = shpKl

        if strKatalogStyle == 'Global':
            TextLengthK = scribus.getTextLength(shpKatalogHot)
            scribus.selectText(0,TextLengthK,shpKatalogHot)
            scribus.setStyle("Katalog",shpKatalogHot)
        else:
            scribus.setFont(strKatalogFont, shpKatalogHot)
            scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
            if strKatalogTextAlign == 'Left':
                scribus.setTextAlignment(0, shpKatalogHot)
            elif strKatalogTextAlign == "Center":
                scribus.setTextAlignment(1, shpKatalogHot)
            elif strKatalogTextAlign == 'Right':
                scribus.setTextAlignment(2, shpKatalogHot)
            elif strKatalogTextAlign == "Justified":
                scribus.setTextAlignment(3, shpKatalogHot)    
            scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)

        (Kw, Kh) = scribus.getSize(shpKatalogHot)
        while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
            Kh -= 1
            scribus.sizeObject(Kw, Kh, shpKatalogHot)
        while ((scribus.textOverflows(shpKatalogHot) > 0)) :
            Kh += 1
            scribus.sizeObject(Kw, Kh, shpKatalogHot)
        lstKS.append(shpKatalogHot)

def funcCaptionPlacementX():
    '''Create working copy of global Placement variables'''
    strPlacementXc = strPlacementX
    strPlacementYc = strPlacementY

    '''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
    if strFrameStyle == 'Internal':
        strFrameOuterWidthI = lstStampW[icnt]
        strFrameOuterHeightI = lstStampH[icnt]
    else:
        strFrameOuterWidthI = strFrameOuterWidth
        strFrameOuterHeightI = strFrameOuterHeight

    '''Substitute stamp width for frame width when building individual components of set'''
    if strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
        strFrameOuterWidthI = lstStampW[icnt]

    '''Add the Captions'''
    global shpCt
    global shpCb
    global shpCr
    global shpCl
    global shpCaptionHot

    if strSingleSet == 'Set' and strSetCaption == 'Group' and icnt == 0:
        strCaptionWidth = strFrameOuterWidth * strCaptionRatio / 100
        strCaptionHeight = float(10)
        strCaptionShift = ((strCaptionWidth - strFrameOuterWidth) / 2)
        if strLayoutCaption == 'Top':
            strCaptionLeft = strPlacementXo - strCaptionShift
            shpCt = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCt' + rnd)
            lstTopShp.append(shpCt)
            scribus.setText(strCaption, shpCt)
            shpCaptionHot = shpCt
        elif strLayoutCaption == 'Bottom':
            strCaptionLeft = strPlacementXo - strCaptionShift
            shpCb = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCb' + rnd)
            lstBottomShp.append(shpCb)
            scribus.setText(strCaption, shpCb)
            shpCaptionHot = shpCb
        elif strLayoutCaption == 'Right':
            strCaptionLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
            shpCr = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCr' + rnd)
            lstRightShpG.append(shpCr)
            scribus.setText(strCaption, shpCr)
            shpCaptionHot = shpCr
        elif strLayoutCaption == 'Left':
            strCaptionLeft = strPlacementXo - strMarginLeft - strCaptionWidth
            shpCl = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCl' + rnd)
            lstLeftShpG.append(shpCl)
            scribus.setText(strCaption, shpCl)
            shpCaptionHot = shpCl

        if strCaptionStyle == 'Global':
            TextLengthC = scribus.getTextLength(shpCaptionHot)
            scribus.selectText(0,TextLengthC,shpCaptionHot)
            scribus.setStyle("Caption",shpCaptionHot)
        else:
            scribus.setFont(strCaptionFont, shpCaptionHot)
            scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
            if strCaptionTextAlign == 'Left':
                scribus.setTextAlignment(0, shpCaptionHot)
            elif strCaptionTextAlign == "Center":
                scribus.setTextAlignment(1, shpCaptionHot)
            elif strCaptionTextAlign == 'Right':
                scribus.setTextAlignment(2, shpCaptionHot)
            elif strCaptionTextAlign == "Justified":
                scribus.setTextAlignment(3, shpCaptionHot)    
            scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)

        (Cw, Ch) = scribus.getSize(shpCaptionHot)
        while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
            Ch -= 1
            scribus.sizeObject(Cw, Ch, shpCaptionHot)
        while ((scribus.textOverflows(shpCaptionHot) > 0)) :
            Ch += 1
            scribus.sizeObject(Cw, Ch, shpCaptionHot)
        lstCS.append(shpCaptionHot)
    elif strSingleSet == 'Set' and strSetCaption == 'Group' and icnt > 0:
        pass
    else:
        strCaptionWidth = strFrameOuterWidthI * strCaptionRatio / 100
        strCaptionHeight = float(10)
        strCaptionShift = ((strCaptionWidth - strFrameOuterWidthI) / 2)
        if strLayoutCaption == 'Top':
            strCaptionLeft = strPlacementXc - strCaptionShift
            shpCt = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCt' + rnd)
            lstTopShp.append(shpCt)
            scribus.setText(strCaption, shpCt)
            shpCaptionHot = shpCt
        elif strLayoutCaption == 'Bottom':
            strCaptionLeft = strPlacementXc - strCaptionShift
            shpCb = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCb' + rnd)
            lstBottomShp.append(shpCb)
            scribus.setText(strCaption, shpCb)
            shpCaptionHot = shpCb
        elif strLayoutCaption == 'Right':
            strCaptionLeft = strPlacementXc + strFrameOuterWidthI + strMarginRight
            shpCr = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCr' + rnd)
            lstRightShp.append(shpCr)
            scribus.setText(strCaption, shpCr)
            shpCaptionHot = shpCr
        elif strLayoutCaption == 'Left':
            strCaptionLeft = strPlacementXc - strMarginLeft - strCaptionWidth
            shpCl = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCl' + rnd)
            lstLeftShp.append(shpCl)
            scribus.setText(strCaption, shpCl)
            shpCaptionHot = shpCl

        if strCaptionStyle == 'Global':
            TextLengthC = scribus.getTextLength(shpCaptionHot)
            scribus.selectText(0,TextLengthC,shpCaptionHot)
            scribus.setStyle("Caption",shpCaptionHot)
        else:
            scribus.setFont(strCaptionFont, shpCaptionHot)
            scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
            if strCaptionTextAlign == 'Left':
                scribus.setTextAlignment(0, shpCaptionHot)
            elif strCaptionTextAlign == "Center":
                scribus.setTextAlignment(1, shpCaptionHot)
            elif strCaptionTextAlign == 'Right':
                scribus.setTextAlignment(2, shpCaptionHot)
            elif strCaptionTextAlign == "Justified":
                scribus.setTextAlignment(3, shpCaptionHot)    
            scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)

        (Cw, Ch) = scribus.getSize(shpCaptionHot)
        while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
            Ch -= 1
            scribus.sizeObject(Cw, Ch, shpCaptionHot)
        while ((scribus.textOverflows(shpCaptionHot) > 0)) :
            Ch += 1
            scribus.sizeObject(Cw, Ch, shpCaptionHot)
        lstCS.append(shpCaptionHot)

def funcTopPlacementY():
    if strFrameStyle == 'Internal':
        strTempY = scribus.getProperty(shpFo, "yPos") - (((scribus.getProperty(shpFo, "height") * 100/90) - \
        scribus.getProperty(shpFo, "height")) / 2) - strMarginTop
    else:
        strTempY = scribus.getProperty(shpFo, "yPos") - strMarginTop

    if scribus.objectExists('shpCt' + rnd) or scribus.objectExists('shpCt' + rndp):
        scribus.setProperty(shpCt, "yPos", strTempY - scribus.getProperty(shpCt, "height"))
        strTempY = scribus.getProperty(shpCt, "yPos") - strVerticalSpacing
    if scribus.objectExists('shpKt' + rnd) or scribus.objectExists('shpKt' + rndp):
        scribus.setProperty(shpKt, "yPos", strTempY - scribus.getProperty(shpKt, "height"))
        strTempY = scribus.getProperty(shpKt, "yPos") - strVerticalSpacing
    if scribus.objectExists('shpDt' + rnd) or scribus.objectExists('shpDt' + rndp):
        scribus.setProperty(shpDt, "yPos", strTempY - scribus.getProperty(shpDt, "height"))
        strTempY = scribus.getProperty(shpDt, "yPos") - strVerticalSpacing
    if scribus.objectExists('shpTt' + rnd) or scribus.objectExists('shpTt' + rndp):
        scribus.setProperty(shpTt, "yPos", strTempY - scribus.getProperty(shpTt, "height"))

def funcBottomPlacementY():
    '''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
    if strFrameStyle == 'Internal':
        strFrameOuterHeightI = lstStampH[icnt]
        strTempY = scribus.getProperty(shpFo, "yPos") - (((scribus.getProperty(shpFo, "height") * 100/90) - \
        scribus.getProperty(shpFo, "height")) / 2) + strFrameOuterHeightI + strMarginBottom
    else:
        strFrameOuterHeightI = strFrameOuterHeight
        strTempY = scribus.getProperty(shpFo, "yPos") + strFrameOuterHeightI + strMarginBottom

    if scribus.objectExists('shpTb' + rnd) or scribus.objectExists('shpTb' + rndp):
        scribus.setProperty(shpTb, "yPos", strTempY)
        strTempY = scribus.getProperty(shpTb, "yPos") + scribus.getProperty(shpTb, "height") + strVerticalSpacing
    if scribus.objectExists('shpDb' + rnd) or scribus.objectExists('shpdb' + rndp):
        scribus.setProperty(shpDb, "yPos", strTempY)
        strTempY = scribus.getProperty(shpDb, "yPos") + scribus.getProperty(shpDb, "height") + strVerticalSpacing
    if scribus.objectExists('shpKb' + rnd) or scribus.objectExists('shpKb' + rndp):
        if strStyle == 'Inside':
            if strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + strFrameOffset + \
                strPaddingTop + (strSetMaxH / 2) - (scribus.getProperty(shpKb, "height") / 2))
            elif strSingleSet == 'Set' and strSetOrientation == 'Vertical':
                if strSetKatalog == 'Individual':
                    scribus.setProperty(shpKb, "yPos", strPlacementY + (lstStampH[icnt] / 2) - \
                    (scribus.getProperty(shpKb, "height") / 2))
                else:
                    scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
                    (strFrameOuterHeight / 2) - (scribus.getProperty(shpKb, "height") / 2))
            elif strFrameStyle == 'Internal':
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") - \
                (((scribus.getProperty(shpFo, "height") * 100/90) - scribus.getProperty(shpFo, "height")) / 2) + \
                (lstStampH[icnt] / 2) - (scribus.getProperty(shpKb, "height") / 2))
            else:
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + strFrameOffset + \
                strPaddingTop + (lstStampH[icnt] / 2) - (scribus.getProperty(shpKb, "height") / 2))
        elif strStyle == 'Outside/Inside':
            if strSingleSet == 'Set' and strSetOrientation == 'Horizontal' and strSetKatalog == 'Group':
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
                strFrameOffset + strPaddingTop + strSetMaxH + strOISpacing)
            elif strSingleSet == 'Set' and strSetOrientation == 'Horizontal' and strSetKatalog == 'Individual':
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
                strFrameOffset + strPaddingTop + strSetMaxH + strOISpacing)
            elif strSingleSet == 'Set' and strSetOrientation == 'Vertical' and strSetKatalog == 'Individual':
                scribus.setProperty(shpKb, "yPos", strPlacementY + (lstStampH[icnt] + strOISpacing))
            elif strSingleSet == 'Set' and strSetOrientation == 'Vertical' and strSetKatalog == 'Group':
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
                strFrameOffset + strPaddingTop + strSetTotH + (strVerticalSpacing * (strSetCount - 1)) + strOISpacing)
            else:
                scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
                strFrameOffset + strPaddingTop + lstStampH[icnt] + strOISpacing)
                '''scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
                strFrameOffset + strPaddingTop + ((strSetMaxH - lstStampH[icnt]) / 2) + \
                lstStampH[icnt] + strOISpacing)'''
        else:
            scribus.setProperty(shpKb, "yPos", strTempY)
            strTempY = scribus.getProperty(shpKb, "yPos") + scribus.getProperty(shpKb, "height") + strVerticalSpacing
    if scribus.objectExists('shpCb' + rnd):
        scribus.setProperty(shpCb, "yPos", strTempY)

def funcRightPlacementY():
    '''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
    '''if strFrameStyle == 'Internal':
        strFrameOuterHeightI = lstStampH[icnt]
        strVertOffset = (strFrameOuterHeightI - strRightOverallHeight) / 2
        strTempY = scribus.getProperty(shpFo, "yPos") - (((scribus.getProperty(shpFo, "height") * 100/85) - \
        scribus.getProperty(shpFo, "height")) / 2) + strVertOffset'''

    if strSingleSet == 'Singles':
        strFrameOuterHeightI = strFrameOuterHeight
        strVertOffset = (strFrameOuterHeightI - strRightOverallHeight) / 2
        strTempY = scribus.getProperty(shpFo, "yPos") + strVertOffset
        if scribus.objectExists('shpTr' + rnd):
            scribus.setProperty(shpTr, "yPos", strTempY)
            strTempY = scribus.getProperty(shpTr, "yPos") + scribus.getProperty(shpTr, "height") + strVerticalSpacing
        if scribus.objectExists('shpDr' + rnd):
            scribus.setProperty(shpDr, "yPos", strTempY)
            strTempY = scribus.getProperty(shpDr, "yPos") + scribus.getProperty(shpDr, "height") + strVerticalSpacing
        if scribus.objectExists('shpKr' + rnd):
            scribus.setProperty(shpKr, "yPos", strTempY)
            strTempY = scribus.getProperty(shpKr, "yPos") + scribus.getProperty(shpKr, "height") + strVerticalSpacing
        if scribus.objectExists('shpCr' + rnd):
            scribus.setProperty(shpCr, "yPos", strTempY)
    elif strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
        strFrameOuterHeightI = strFrameOuterHeight
        strVertOffset = (strFrameOuterHeightI - strRightOverallHeightG) / 2
        strTempY = scribus.getProperty(shpFo, "yPos") + strVertOffset
        if scribus.objectExists('shpTr' + rnd):
            scribus.setProperty(shpTr, "yPos", strTempY)
            strTempY = scribus.getProperty(shpTr, "yPos") + scribus.getProperty(shpTr, "height") + strVerticalSpacing
        if scribus.objectExists('shpDr' + rnd):
            scribus.setProperty(shpDr, "yPos", strTempY)
            strTempY = scribus.getProperty(shpDr, "yPos") + scribus.getProperty(shpDr, "height") + strVerticalSpacing
        if scribus.objectExists('shpKr' + rnd):
            scribus.setProperty(shpKr, "yPos", strTempY)
            strTempY = scribus.getProperty(shpKr, "yPos") + scribus.getProperty(shpKr, "height") + strVerticalSpacing
        if scribus.objectExists('shpCr' + rnd):
            scribus.setProperty(shpCr, "yPos", strTempY)
    else:
        strFrameOuterHeightI = lstStampH[icnt]
        strVertOffsetI = (strFrameOuterHeightI - strRightOverallHeight) / 2
        strVertOffsetG = (strFrameOuterHeight - strRightOverallHeightG) / 2
        strTempY = strPlacementY + strVertOffsetI
        strTempYG = scribus.getProperty(shpFo, "yPos") + strVertOffsetG
        if scribus.objectExists('shpTr' + rnd):
            if strSetTitle == 'Individual':
                scribus.setProperty(shpTr, "yPos", strTempY)
                strTempY = scribus.getProperty(shpTr, "yPos") + scribus.getProperty(shpTr, "height") + strVerticalSpacing
            else:
                scribus.setProperty(shpTr, "yPos", strTempYG)
                strTempYG = scribus.getProperty(shpTr, "yPos") + scribus.getProperty(shpTr, "height") + strVerticalSpacing
        if scribus.objectExists('shpDr' + rnd):
            if strSetDate == 'Individual':
                scribus.setProperty(shpDr, "yPos", strTempY)
                strTempY = scribus.getProperty(shpDr, "yPos") + scribus.getProperty(shpDr, "height") + strVerticalSpacing
            else:
                scribus.setProperty(shpDr, "yPos", strTempYG)
                strTempYG = scribus.getProperty(shpDr, "yPos") + scribus.getProperty(shpDr, "height") + strVerticalSpacing
        if scribus.objectExists('shpKr' + rnd):
            if strSetKatalog == 'Individual':
                scribus.setProperty(shpKr, "yPos", strTempY)
                strTempY = scribus.getProperty(shpKr, "yPos") + scribus.getProperty(shpKr, "height") + strVerticalSpacing
            else:
                scribus.setProperty(shpKr, "yPos", strTempYG)
                strTempYG = scribus.getProperty(shpKr, "yPos") + scribus.getProperty(shpKr, "height") + strVerticalSpacing
        if scribus.objectExists('shpCr' + rnd):
            if strSetCaption == 'Individual':
                scribus.setProperty(shpCr, "yPos", strTempY)
            else:
                scribus.setProperty(shpCr, "yPos", strTempYG)

def funcLeftPlacementY():
    if strSingleSet == 'Singles':
        strFrameOuterHeightI = strFrameOuterHeight
        strVertOffset = (strFrameOuterHeightI - strLeftOverallHeight) / 2
        strTempY = scribus.getProperty(shpFo, "yPos") + strVertOffset
        if scribus.objectExists('shpTl' + rnd):
            scribus.setProperty(shpTl, "yPos", strTempY)
            strTempY = scribus.getProperty(shpTr, "yPos") + scribus.getProperty(shpTl, "height") + strVerticalSpacing
        if scribus.objectExists('shpDl' + rnd):
            scribus.setProperty(shpDl, "yPos", strTempY)
            strTempY = scribus.getProperty(shpDr, "yPos") + scribus.getProperty(shpDl, "height") + strVerticalSpacing
        if scribus.objectExists('shpKl' + rnd):
            scribus.setProperty(shpKl, "yPos", strTempY)
            strTempY = scribus.getProperty(shpKr, "yPos") + scribus.getProperty(shpKl, "height") + strVerticalSpacing
        if scribus.objectExists('shpCl' + rnd):
            scribus.setProperty(shpCl, "yPos", strTempY)
    elif strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
        strFrameOuterHeightI = strFrameOuterHeight
        strVertOffset = (strFrameOuterHeightI - strLeftOverallHeightG) / 2
        strTempY = scribus.getProperty(shpFo, "yPos") + strVertOffset
        if scribus.objectExists('shpTl' + rnd):
            scribus.setProperty(shpTl, "yPos", strTempY)
            strTempY = scribus.getProperty(shpTl, "yPos") + scribus.getProperty(shpTl, "height") + strVerticalSpacing
        if scribus.objectExists('shpDl' + rnd):
            scribus.setProperty(shpDl, "yPos", strTempY)
            strTempY = scribus.getProperty(shpDl, "yPos") + scribus.getProperty(shpDl, "height") + strVerticalSpacing
        if scribus.objectExists('shpKl' + rnd):
            scribus.setProperty(shpKl, "yPos", strTempY)
            strTempY = scribus.getProperty(shpKl, "yPos") + scribus.getProperty(shpKl, "height") + strVerticalSpacing
        if scribus.objectExists('shpCl' + rnd):
            scribus.setProperty(shpCl, "yPos", strTempY)
    else:
        strFrameOuterHeightI = lstStampH[icnt]
        strVertOffsetI = (strFrameOuterHeightI - strLeftOverallHeight) / 2
        strVertOffsetG = (strFrameOuterHeight - strLeftOverallHeightG) / 2
        strTempY = strPlacementY + strVertOffsetI
        strTempYG = scribus.getProperty(shpFo, "yPos") + strVertOffsetG
        if scribus.objectExists('shpTl' + rnd):
            if strSetTitle == 'Individual':
                scribus.setProperty(shpTl, "yPos", strTempY)
                strTempY = scribus.getProperty(shpTl, "yPos") + scribus.getProperty(shpTl, "height") + strVerticalSpacing
            else:
                scribus.setProperty(shpTl, "yPos", strTempYG)
                strTempYG = scribus.getProperty(shpTl, "yPos") + scribus.getProperty(shpTl, "height") + strVerticalSpacing
        if scribus.objectExists('shpDl' + rnd):
            if strSetDate == 'Individual':
                scribus.setProperty(shpDl, "yPos", strTempY)
                strTempY = scribus.getProperty(shpDl, "yPos") + scribus.getProperty(shpDl, "height") + strVerticalSpacing
            else:
                scribus.setProperty(shpDl, "yPos", strTempYG)
                strTempYG = scribus.getProperty(shpDl, "yPos") + scribus.getProperty(shpDl, "height") + strVerticalSpacing
        if scribus.objectExists('shpKl' + rnd):
            if strSetKatalog == 'Individual':
                scribus.setProperty(shpKl, "yPos", strTempY)
                strTempY = scribus.getProperty(shpKl, "yPos") + scribus.getProperty(shpKl, "height") + strVerticalSpacing
            else:
                scribus.setProperty(shpKl, "yPos", strTempYG)
                strTempYG = scribus.getProperty(shpKl, "yPos") + scribus.getProperty(shpKl, "height") + strVerticalSpacing
        if scribus.objectExists('shpCl' + rnd):
            if strSetCaption == 'Individual':
                scribus.setProperty(shpCl, "yPos", strTempY)
            else:
                scribus.setProperty(shpCl, "yPos", strTempYG)

def funcCenterMiddles():
    intLe = len(lstLeftShp)
    intLeG = len(lstLeftShpG)
    global strLeftOverallHeight
    global strLeftOverallHeightG
    Bh = 0
    BhG = 0

    if scribus.objectExists('shpTl' + rnd):
        if strSingleSet == 'Set' and strSetTitle == 'Group':
            intHG = scribus.getProperty(shpTl, "height")
            BhG = BhG + intHG
        else:
            intH = scribus.getProperty(shpTl, "height")
            Bh = Bh + intH
    if scribus.objectExists('shpDl' + rnd):
        if strSingleSet == 'Set' and strSetDate == 'Group':
            intHG = scribus.getProperty(shpDl, "height")
            BhG = BhG + intHG
        else:
            intH = scribus.getProperty(shpDl, "height")
            Bh = Bh + intH
    if scribus.objectExists('shpKl' + rnd):
        if strSingleSet == 'Set' and strSetKatalog == 'Group':
            intHG = scribus.getProperty(shpKl, "height")
            BhG = BhG + intHG
        else:
            intH = scribus.getProperty(shpKl, "height")
            Bh = Bh + intH
    if scribus.objectExists('shpCl' + rnd):
        if strSingleSet == 'Set' and strSetCaption == 'Group':
            intHG = scribus.getProperty(shpCl, "height")
            BhG = BhG + intHG
        else:
            intH = scribus.getProperty(shpCl, "height")
            Bh = Bh + intH

    strLeftOverallHeight = Bh + ((intLe - 1) * strVerticalSpacing)
    strLeftOverallHeightG = BhG + ((intLeG - 1) * strVerticalSpacing)

    intRe = len(lstRightShp)
    intReG = len(lstRightShpG)
    global strRightOverallHeight
    global strRightOverallHeightG
    Bk = 0
    BkG = 0

    if scribus.objectExists('shpTr' + rnd):
        if strSingleSet == 'Set' and strSetTitle == 'Group':
            intKG = scribus.getProperty(shpTr, "height")
            BkG = BkG + intKG
        else:
            intK = scribus.getProperty(shpTr, "height")
            Bk = Bk + intK
    if scribus.objectExists('shpDr' + rnd):
        if strSingleSet == 'Set' and strSetDate == 'Group':
            intKG = scribus.getProperty(shpDr, "height")
            BkG = BkG + intKG
        else:
            intK = scribus.getProperty(shpDr, "height")
            Bk = Bk + intK
    if scribus.objectExists('shpKr' + rnd):
        if strSingleSet == 'Set' and strSetKatalog == 'Group':
            intKG = scribus.getProperty(shpKr, "height")
            BkG = BkG + intKG
        else:
            intK = scribus.getProperty(shpKr, "height")
            Bk = Bk + intK
    if scribus.objectExists('shpCr' + rnd):
        if strSingleSet == 'Set' and strSetCaption == 'Group':
            intKG = scribus.getProperty(shpCr, "height")
            BkG = BkG + intKG
        else:
            intK = scribus.getProperty(shpCr, "height")
            Bk = Bk + intK

    strRightOverallHeight = Bk + ((intRe - 1) * strVerticalSpacing)
    strRightOverallHeightG = BkG + ((intReG - 1) * strVerticalSpacing)

def funcGroupAndAlign(): 
    lstObjects = []

    lstObjects.extend(lstFo)
    lstObjects.extend(lstFi)
    lstObjects.extend(lstP)
    lstObjects.extend(lstTopShp)
    lstObjects.extend(lstBottomShp)
    lstObjects.extend(lstRightShp)
    lstObjects.extend(lstLeftShp)

    if strSingleSet == 'Set':
        lstObjects.extend(lstPS)
        lstObjects.extend(lstTS)
        lstObjects.extend(lstDS)
        lstObjects.extend(lstKS)
        lstObjects.extend(lstCS)

    if len(lstObjects) > 1:
        scribus.groupObjects(lstObjects)

funcImportSettings()
